//+------------------------------------------------------------------+
//|                                                     YaOPOrek.mq4 |
//|                                        Copyright  2008, masemus |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, masemus"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern int Shift_UP_DN =0; 
extern int Adjust_Side_to_side  = 0;
extern color Label_color = SlateGray;

//****************************************
extern int RSI_Period = 5;
extern int RSI_PRICE_TYPE = 0;

extern int STOCH_K_Period = 5;
extern int STOCH_D_Period = 3;
extern int STOCH_Slowing = 3;
extern int STOCH_MA_MODE = 1;

extern int MA_Fast = 1;
extern int MA_Med = 4;
extern int MA_Slow = 20;
extern int MA_MODE = 0;
extern int MA_PRICE_TYPE = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL);
   ObjectsDeleteAll(1,OBJ_LABEL);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
   //***********************************************************************************************************************
   //LABEL
   int    counted_bars=IndicatorCounted();
//----
      
   //*************************************************************************************************************** 
   //SiGNAL TRend

   double rsi_d1 = iRSI(NULL, PERIOD_D1, RSI_Period , RSI_PRICE_TYPE, 0);
   double rsi_h4 = iRSI(NULL, PERIOD_H4, RSI_Period , RSI_PRICE_TYPE, 0);
   double rsi_h1 = iRSI(NULL, PERIOD_H1, RSI_Period , RSI_PRICE_TYPE, 0);
   double rsi_m30 = iRSI(NULL, PERIOD_M30, RSI_Period , RSI_PRICE_TYPE, 0);
   double rsi_m15 = iRSI(NULL, PERIOD_M15, RSI_Period , RSI_PRICE_TYPE, 0);
   double rsi_m5 = iRSI(NULL, PERIOD_M5, RSI_Period , RSI_PRICE_TYPE, 0);
   double rsi_m1 = iRSI(NULL, PERIOD_M1, RSI_Period , RSI_PRICE_TYPE, 0);
   
   double stoc_D1 = iStochastic(NULL, PERIOD_D1, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double stoc_H4 = iStochastic(NULL, PERIOD_H4, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double stoc_H1 = iStochastic(NULL, PERIOD_H1, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double stoc_M30 = iStochastic(NULL, PERIOD_M30, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double stoc_M15 = iStochastic(NULL, PERIOD_M15, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double stoc_M5 = iStochastic(NULL, PERIOD_M5, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   double stoc_M1 = iStochastic(NULL, PERIOD_M1, STOCH_K_Period,STOCH_D_Period,STOCH_Slowing, STOCH_MA_MODE, 0, MODE_MAIN, 0);
   
   double MA1_M1 = iMA(Symbol(),1,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA2_M1 = iMA(Symbol(),1,MA_Med,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA3_M1 = iMA(Symbol(),1,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA1_M5 = iMA(Symbol(),5,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA2_M5 = iMA(Symbol(),5,MA_Med,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA3_M5 = iMA(Symbol(),5,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA1_M15 = iMA(Symbol(),15,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA2_M15 = iMA(Symbol(),15,MA_Med,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA3_M15 = iMA(Symbol(),15,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA1_M30 = iMA(Symbol(),30,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA2_M30 = iMA(Symbol(),30,MA_Med,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA3_M30 = iMA(Symbol(),30,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA1_H1 = iMA(Symbol(),60,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA2_H1 = iMA(Symbol(),60,MA_Med,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA3_H1 = iMA(Symbol(),60,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA1_H4 = iMA(Symbol(),240,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA2_H4 = iMA(Symbol(),240,MA_Med,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA3_H4 = iMA(Symbol(),240,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA1_D1 = iMA(Symbol(),1440,MA_Fast,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA2_D1 = iMA(Symbol(),1440,MA_Med,0,MA_MODE,MA_PRICE_TYPE,0);
   double MA3_D1 = iMA(Symbol(),1440,MA_Slow,0,MA_MODE,MA_PRICE_TYPE,0);

   string G_m1 = "", G_m5 = "", G_m15 = "", G_m30 = "", G_h1 = "", G_h4 = "", G_d1 = "";
   color  color_signal, color_m1, color_m5, color_m15, color_m30, color_h1, color_h4, color_d1;
   
   if ((rsi_d1 > 50) && (stoc_D1 > 50) && (MA1_D1 > MA3_D1)) { G_d1 = "-"; color_d1 = DodgerBlue;}  
   if ((rsi_h4 > 50) && (stoc_H4 > 50) && (MA1_H4 > MA3_H4)) { G_h4 = "-"; color_h4 = DodgerBlue;}  
   if ((rsi_h1 > 50) && (stoc_H1 > 50) && (MA1_H1 > MA3_H1)) { G_h1 = "-"; color_h1 = DodgerBlue;}
   if ((rsi_m30 > 50) && (stoc_M30 > 50) && (MA1_M30 > MA3_M30)) { G_m30 = "-"; color_m30 = DodgerBlue; }
   if ((rsi_m15 > 50) && (stoc_M15 > 50) && (MA1_M15 > MA3_M15)) { G_m15 = "-"; color_m15 = DodgerBlue; }
   if ((rsi_m5 > 50) && (stoc_M5 > 50) && (MA1_M5 > MA3_M5)) { G_m5 = "-"; color_m5 = DodgerBlue;}
   if ((rsi_m1 > 50) && (stoc_M1 > 50) && (MA1_M1 > MA3_M1)) { G_m1 = "-"; color_m1 = DodgerBlue;}
   
   if ((rsi_d1 < 50) && (stoc_D1 < 50) && (MA1_D1 < MA3_D1)) { G_d1 = "-"; color_d1 = DeepPink;}
   if ((rsi_h4 < 50) && (stoc_H4 < 50) && (MA1_H4 < MA3_H4)) { G_h4 = "-"; color_h4 = DeepPink;}
   if ((rsi_h1 < 50) && (stoc_H1 < 50) && (MA1_H1 < MA3_H1)) { G_h1 = "-"; color_h1 = DeepPink;}
   if ((rsi_m30 < 50) && (stoc_M30 < 50) && (MA1_M30 < MA3_M30)) { G_m30 = "-"; color_m30 = DeepPink;}
   if ((rsi_m15 < 50) && (stoc_M15 < 50) && (MA1_M15 < MA3_M15)) { G_m15 = "-"; color_m15 = DeepPink;}
   if ((rsi_m5 < 50) && (stoc_M5 < 50) && (MA1_M5 < MA3_M5)) { G_m5 = "-"; color_m5 = DeepPink;}
   if ((rsi_m1 < 50) && (stoc_M1 < 50) && (MA1_M1 < MA3_M1)) { G_m1 = "-"; color_m1 = DeepPink;}
   
   if ((rsi_m1 >= 50) && (stoc_M1 <= 50) && (MA1_M1 <= MA3_M1)) { G_m1 = "-"; color_m1 = SlateGray;}
   if ((rsi_m1 < 50) && (stoc_M1 > 50) && (MA1_M1 > MA3_M1)) { G_m1 = "-"; color_m1 = SlateGray;}
   if ((rsi_m1 < 50) && (stoc_M1 > 50) && (MA1_M1 < MA3_M1)) { G_m1 = "-"; color_m1 = LightPink;}
   if ((rsi_m1 > 50) && (stoc_M1 < 50) && (MA1_M1 > MA3_M1)) { G_m1 = "-"; color_m1 = LightSkyBlue;}
   if ((rsi_m1 < 50) && (stoc_M1 < 50) && (MA1_M1 > MA3_M1)) { G_m1 = "-"; color_m1 = SlateGray;}
   if ((rsi_m1 > 50) && (stoc_M1 > 50) && (MA1_M1 < MA3_M1)) { G_m1 = "-"; color_m1 = SlateGray;}
   
   if ((rsi_m5 >= 50) && (stoc_M5 <= 50) && (MA1_M5 <= MA3_M5)) { G_m5 = "-"; color_m5 = SlateGray;}
   if ((rsi_m5 < 50) && (stoc_M5 > 50) && (MA1_M5 > MA3_M5)) { G_m5 = "-"; color_m5 = SlateGray;}
   if ((rsi_m5 < 50) && (stoc_M5 > 50) && (MA1_M5 < MA3_M5)) { G_m5 = "-"; color_m5 = LightPink;}
   if ((rsi_m5 > 50) && (stoc_M5 < 50) && (MA1_M5 > MA3_M5)) { G_m5 = "-"; color_m5 = LightSkyBlue;}
   if ((rsi_m5 < 50) && (stoc_M5 < 50) && (MA1_M5 > MA3_M5)) { G_m5 = "-"; color_m5 = SlateGray;}
   if ((rsi_m5 > 50) && (stoc_M5 > 50) && (MA1_M5 < MA3_M5)) { G_m5 = "-"; color_m5 = SlateGray;}
   
   if ((rsi_m15 >= 50) && (stoc_M15 <= 50) && (MA1_M15 <= MA3_M15)) { G_m15 = "-"; color_m15 = SlateGray;}
   if ((rsi_m15 < 50) && (stoc_M15 > 50) && (MA1_M15 > MA3_M15)) { G_m15 = "-"; color_m15 = SlateGray;}
   if ((rsi_m15 < 50) && (stoc_M15 > 50) && (MA1_M15 < MA3_M15)) { G_m15 = "-"; color_m15 = LightPink;}
   if ((rsi_m15 > 50) && (stoc_M15 < 50) && (MA1_M15 > MA3_M15)) { G_m15 = "-"; color_m15 = LightSkyBlue;}
   if ((rsi_m15 < 50) && (stoc_M15 < 50) && (MA1_M15 > MA3_M15)) { G_m15 = "-"; color_m15 = SlateGray;}
   if ((rsi_m15 > 50) && (stoc_M15 > 50) && (MA1_M15 < MA3_M15)) { G_m15 = "-"; color_m15 = SlateGray;}
      
   if ((rsi_m30 >= 50) && (stoc_M30 <= 50) && (MA1_M30 <= MA3_M30)) { G_m30 = "-"; color_m30 = SlateGray;}
   if ((rsi_m30 < 50) && (stoc_M30 > 50) && (MA1_M30 > MA3_M30)) { G_m30 = "-"; color_m30 = SlateGray;}
   if ((rsi_m30 < 50) && (stoc_M30 > 50) && (MA1_M30 < MA3_M30)) { G_m30 = "-"; color_m30 = LightPink;}
   if ((rsi_m30 > 50) && (stoc_M30 < 50) && (MA1_M30 > MA3_M30)) { G_m30 = "-"; color_m30 = LightSkyBlue;}
   if ((rsi_m30 < 50) && (stoc_M30 < 50) && (MA1_M30 > MA3_M30)) { G_m30 = "-"; color_m30 = SlateGray;}
   if ((rsi_m30 > 50) && (stoc_M30 > 50) && (MA1_M30 < MA3_M30)) { G_m30 = "-"; color_m30 = SlateGray;}
   
   if ((rsi_h1 >= 50) && (stoc_H1 <= 50) && (MA1_H1 <= MA3_H1)) { G_h1 = "-"; color_h1 = SlateGray;}
   if ((rsi_h1 < 50) && (stoc_H1 > 50) && (MA1_H1 > MA3_H1)) { G_h1 = "-"; color_h1 = SlateGray;}
   if ((rsi_h1 < 50) && (stoc_H1 > 50) && (MA1_H1 < MA3_H1)) { G_h1 = "-"; color_h1 = LightPink;}
   if ((rsi_h1 > 50) && (stoc_H1 < 50) && (MA1_H1 > MA3_H1)) { G_h1 = "-"; color_h1 = LightSkyBlue;}
   if ((rsi_h1 < 50) && (stoc_H1 < 50) && (MA1_H1 > MA3_H1)) { G_h1 = "-"; color_h1 = SlateGray;}
   if ((rsi_h1 > 50) && (stoc_H1 > 50) && (MA1_H1 < MA3_H1)) { G_h1 = "-"; color_h1 = SlateGray;}
   
   if ((rsi_h4 >= 50) && (stoc_H4 <= 50) && (MA1_H4 <= MA3_H4)) { G_h4 = "-"; color_h4 = SlateGray;}
   if ((rsi_h4 < 50) && (stoc_H4 > 50) && (MA1_H4 > MA3_H4)) { G_h4 = "-"; color_h4 = SlateGray;}
   if ((rsi_h4 < 50) && (stoc_H4 > 50) && (MA1_H4 < MA3_H4)) { G_h4 = "-"; color_h4 = LightPink;}
   if ((rsi_h4 > 50) && (stoc_H4 < 50) && (MA1_H4 > MA3_H4)) { G_h4 = "-"; color_h4 = LightSkyBlue;}
   if ((rsi_h4 < 50) && (stoc_H4 < 50) && (MA1_H4 > MA3_H4)) { G_h4 = "-"; color_h4 = SlateGray;}
   if ((rsi_h4 > 50) && (stoc_H4 > 50) && (MA1_H4 < MA3_H4)) { G_h4 = "-"; color_h4 = SlateGray;}
   
   if ((rsi_d1 >= 50) && (stoc_D1 <= 50) && (MA1_D1 <= MA3_D1)) { G_d1 = "-"; color_d1 = SlateGray;}
   if ((rsi_d1 < 50) && (stoc_D1 > 50) && (MA1_D1 > MA3_D1)) { G_d1 = "-"; color_d1 = SlateGray;}
   if ((rsi_d1 < 50) && (stoc_D1 > 50) && (MA1_D1 < MA3_D1)) { G_d1 = "-"; color_d1 = LightPink;}
   if ((rsi_d1 > 50) && (stoc_D1 < 50) && (MA1_D1 > MA3_D1)) { G_d1 = "-"; color_d1 = LightSkyBlue;}
   if ((rsi_d1 < 50) && (stoc_D1 < 50) && (MA1_D1 > MA3_D1)) { G_d1 = "-"; color_d1 = SlateGray;}
   if ((rsi_d1 > 50) && (stoc_D1 > 50) && (MA1_D1 < MA3_D1)) { G_d1 = "-"; color_d1 = SlateGray;}
               
   //******************************************************************************************************************
   //SiGNAL ReVersal 
   
   string RV_m1 = "", RV_m5 = "", RV_m15 = "", RV_m30 = "", RV_h1 = "", RV_h4 = "", RV_d1 = "";
   color  clr_signal, clr_m1, clr_m5, clr_m15, clr_m30, clr_h1, clr_h4, clr_d1;
   
   if ((rsi_d1 > 70) && (stoc_D1 > 80) && (MA1_D1 < MA2_D1)) { RV_d1 = "-"; clr_d1 = DeepPink;}  
   if ((rsi_h4 > 70) && (stoc_H4 > 80) && (MA1_H4 < MA2_H4)) { RV_h4 = "-"; clr_h4 = DeepPink;}  
   if ((rsi_h1 > 70) && (stoc_H1 > 80) && (MA1_H1 < MA2_H1)) { RV_h1 = "-"; clr_h1 = DeepPink;}
   if ((rsi_m30 > 70) && (stoc_M30 > 80) && (MA1_M30 < MA2_M30)) { RV_m30 = "-"; clr_m30 = DeepPink; }
   if ((rsi_m15 > 70) && (stoc_M15 > 80) && (MA1_M15 < MA2_M15)) { RV_m15 = "-"; clr_m15 = DeepPink; }
   if ((rsi_m5 > 70) && (stoc_M5 > 80) && (MA1_M5 < MA2_M5)) { RV_m5 = "-"; clr_m5 = DeepPink;}
   if ((rsi_m1 > 70) && (stoc_M1 > 80) && (MA1_M1 < MA2_M1)) { RV_m1 = "-"; clr_m1 = DeepPink;}
   
   if ((rsi_d1 < 30) && (stoc_D1 < 20) && (MA1_D1 > MA2_D1)) { RV_d1 = "-"; clr_d1 = DodgerBlue;}
   if ((rsi_h4 < 30) && (stoc_H4 < 20) && (MA1_H4 > MA2_H4)) { RV_h4 = "-"; clr_h4 = DodgerBlue;}
   if ((rsi_h1 < 30) && (stoc_H1 < 20) && (MA1_H1 > MA2_H1)) { RV_h1 = "-"; clr_h1 = DodgerBlue;}
   if ((rsi_m30 < 30) && (stoc_M30 < 20) && (MA1_M30 > MA2_M30)) { RV_m30 = "-"; clr_m30 = DodgerBlue;}
   if ((rsi_m15 < 30) && (stoc_M15 < 20) && (MA1_M15 > MA2_M15)) { RV_m15 = "-"; clr_m15 = DodgerBlue;}
   if ((rsi_m5 < 30) && (stoc_M5 < 20) && (MA1_M5 > MA2_M5)) { RV_m5 = "-"; clr_m5 = DodgerBlue;}
   if ((rsi_m1 < 30) && (stoc_M1 < 20) && (MA1_M1 > MA2_M1)) { RV_m1 = "-"; clr_m1 = DodgerBlue;}

   //******************************************************************************************************************
   //SiGNAL BuySell 

   string BS_m1 = "", BS_m5 = "", BS_m15 = "", BS_m30 = "", BS_h1 = "", BS_h4 = "", BS_d1 = "";
   color  cOlr_signal, cOlr_m1, cOlr_m5, cOlr_m15, cOlr_m30, cOlr_h1, cOlr_h4, cOlr_d1;
   
   if ((MA1_M1 < MA2_M1) && (MA1_M1 < MA3_M1)) { BS_m1 = "-"; cOlr_m1 = DeepPink;}
   if ((MA1_M1 <= MA2_M1) && (MA1_M1 >= MA3_M1)) { BS_m1 = "-"; cOlr_m1 = LightPink;}
   if ((MA1_M1 > MA2_M1) && (MA1_M1 < MA3_M1)) { BS_m1 = "-"; cOlr_m1 = LightSkyBlue;}
   if ((MA1_M1 > MA2_M1) && (MA1_M1 > MA3_M1)) { BS_m1 = "-"; cOlr_m1 = DodgerBlue;}
   
   if ((MA1_M5 < MA2_M5) && (MA1_M5 < MA3_M5)) { BS_m5 = "-"; cOlr_m5 = DeepPink;}
   if ((MA1_M5 <= MA2_M5) && (MA1_M5 >= MA3_M5)) { BS_m5 = "-"; cOlr_m5 = LightPink;}
   if ((MA1_M5 > MA2_M5) && (MA1_M5 < MA3_M5)) { BS_m5 = "-"; cOlr_m5 = LightSkyBlue;}
   if ((MA1_M5 > MA2_M5) && (MA1_M5 > MA3_M5)) { BS_m5 = "-"; cOlr_m5 = DodgerBlue;}
   
   if ((MA1_M15 < MA2_M15) && (MA1_M15 < MA3_M15)) { BS_m15 = "-"; cOlr_m15 = DeepPink;}
   if ((MA1_M15 <= MA2_M15) && (MA1_M15 >= MA3_M15)) { BS_m15 = "-"; cOlr_m15 = LightPink;}
   if ((MA1_M15 > MA2_M15) && (MA1_M15 < MA3_M15)) { BS_m15 = "-"; cOlr_m15 = LightSkyBlue;}
   if ((MA1_M15 > MA2_M15) && (MA1_M15 > MA3_M15)) { BS_m15 = "-"; cOlr_m15 = DodgerBlue; }
      
   if ((MA1_M30 < MA2_M30) && (MA1_M30 < MA3_M30)) { BS_m30 = "-"; cOlr_m30 = DeepPink;}
   if ((MA1_M30 <= MA2_M30) && (MA1_M30 >= MA3_M30)) { BS_m30 = "-"; cOlr_m30 = LightPink;}
   if ((MA1_M30 > MA2_M30) && (MA1_M30 < MA3_M30)) { BS_m30 = "-"; cOlr_m30 = LightSkyBlue;}
   if ((MA1_M30 > MA2_M30) && (MA1_M30 > MA3_M30)) { BS_m30 = "-"; cOlr_m30 = DodgerBlue; }
   
   if ((MA1_H1 < MA2_H1) && (MA1_H1 < MA3_H1)) { BS_h1 = "-"; cOlr_h1 = DeepPink;}
   if ((MA1_H1 <= MA2_H1) && (MA1_H1 >= MA3_H1)) { BS_h1 = "-"; cOlr_h1 = LightPink;}
   if ((MA1_H1 > MA2_H1) && (MA1_H1 < MA3_H1)) { BS_h1 = "-"; cOlr_h1 = LightSkyBlue;}
   if ((MA1_H1 > MA2_H1) && (MA1_H1 > MA3_H1)) { BS_h1 = "-"; cOlr_h1 = DodgerBlue;}
   
   if ((MA1_H4 < MA2_H4) && (MA1_H4 < MA3_H4)) { BS_h4 = "-"; cOlr_h4 = DeepPink;}
   if ((MA1_H4 <= MA2_H4) && (MA1_H4 >= MA3_H4)) { BS_h4 = "-"; cOlr_h4 = LightPink;}
   if ((MA1_H4 > MA2_H4) && (MA1_H4 < MA3_H4)) { BS_h4 = "-"; cOlr_h4 = LightSkyBlue;}
   if ((MA1_H4 > MA2_H4) && (MA1_H4 > MA3_H4)) { BS_h4 = "-"; cOlr_h4 = DodgerBlue;}  
   
   if ((MA1_D1 < MA2_D1) && (MA1_D1 < MA3_D1)) { BS_d1 = "-"; cOlr_d1 = DeepPink;}
   if ((MA1_D1 <= MA2_D1) && (MA1_D1 >= MA3_D1)) { BS_d1 = "-"; cOlr_d1 = LightPink;}
   if ((MA1_D1 > MA2_D1) && (MA1_D1 < MA3_D1)) { BS_d1 = "-"; cOlr_d1 = LightSkyBlue;}
   if ((MA1_D1 > MA2_D1) && (MA1_D1 > MA3_D1)) { BS_d1 = "-"; cOlr_d1 = DodgerBlue;}  

   //*****************************************************************************************************
   //Info
   string Teks="", Teks_Menit, Teks_Detik;
   double d_A, d_B;

   //Time for Next Candle
   d_B = (Time[4]-Time[5])-MathMod(CurTime(),Time[4]-Time[5]);
   d_A = d_B/60;
   d_B = (d_A-MathFloor(d_A))*60;
   d_A = MathFloor(d_A);
   Teks_Menit = DoubleToStr(d_A,0);
   Teks_Detik = DoubleToStr(d_B,0);
   Teks=Teks_Menit+":"+Teks_Detik;
           ObjectCreate("Candle_Time", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Candle_Time", OBJPROP_CORNER, 3);
   ObjectSetText("Candle_Time", Teks_Menit+":"+Teks_Detik, 8, "Arial Bold", White);
   ObjectSet("Candle_Time", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("Candle_Time", OBJPROP_YDISTANCE, 85+Shift_UP_DN); 
           ObjectCreate("Candle_Time2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Candle_Time2", OBJPROP_CORNER, 3);
   ObjectSetText("Candle_Time2", " Next Candle ", 7, "Arial", Label_color);
   ObjectSet("Candle_Time2", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("Candle_Time2", OBJPROP_YDISTANCE, 75+Shift_UP_DN); 

   //Price
   double Price1 = iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0);   
    Teks=DoubleToStr(Price1,Digits);

   int R1=0,R5=0,R10=0,R20=0,RAvg=0,i=0;
   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   for(i=1;i<=5;i++)
      R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=10;i++)
      R10   =    R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=20;i++)
      R20   =    R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;

   R5 = R5/5;
   R10 = R10/10;
   R20 = R20/20;
   RAvg  =  (R1+R5+R10+R20)/4;    
   
   string HI="",LO="",SPREAD="",PIPS="",DAV="",HILO="",PRC,Pips="",Av="",AV_Yest="";
   color color_pip,color_av;
   double OPEN = iOpen(NULL,1440,0);
   double CLOSE = iClose(NULL,1440,0);
   double SPRD = (Ask - Bid)/Point;
   double High_Today = iHigh(NULL,1440,0);
   double Low_Today = iLow(NULL,1440,0);
   PIPS =  DoubleToStr((CLOSE-OPEN)/Point,0);
   SPREAD = (DoubleToStr(SPRD,Digits-4));
   DAV = (DoubleToStr(RAvg,Digits-4));
   AV_Yest =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   HILO = DoubleToStr((High_Today-Low_Today)/Point,0);
  
     if (CLOSE >= OPEN) {Pips= "-";color_pip = Lime; }
     if (CLOSE < OPEN) {Pips= "-";color_pip = OrangeRed; }
      if (DAV > AV_Yest) {Av= "-";color_av = Lime; }
     if (DAV < AV_Yest) {Av= "-";color_av = OrangeRed; }

   //SiGNAL ReVersal
           ObjectCreate("MAtext", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("MAtext","RV", 7, "Arial",  Label_color);
   ObjectSet("MAtext", OBJPROP_CORNER, 3);
   ObjectSet("MAtext", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("MAtext", OBJPROP_YDISTANCE, 55+Shift_UP_DN);  
           ObjectCreate("SignalRVd1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalRVd1"," * ", 16, "Arial Bold",  clr_d1);
   ObjectSet("SignalRVd1", OBJPROP_CORNER, 3);
   ObjectSet("SignalRVd1", OBJPROP_XDISTANCE, 15+Adjust_Side_to_side);
   ObjectSet("SignalRVd1", OBJPROP_YDISTANCE, 45+Shift_UP_DN);  
           ObjectCreate("SignalRVh4", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalRVh4"," * ", 16, "Arial Bold",  clr_h4);
   ObjectSet("SignalRVh4", OBJPROP_CORNER, 3);
   ObjectSet("SignalRVh4", OBJPROP_XDISTANCE, 25+Adjust_Side_to_side);
   ObjectSet("SignalRVh4", OBJPROP_YDISTANCE, 45+Shift_UP_DN);  
           ObjectCreate("SignalRVh1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalRVh1"," * ", 16, "Arial Bold",  clr_h1);
   ObjectSet("SignalRVh1", OBJPROP_CORNER, 3);
   ObjectSet("SignalRVh1", OBJPROP_XDISTANCE, 35+Adjust_Side_to_side);
   ObjectSet("SignalRVh1", OBJPROP_YDISTANCE, 45+Shift_UP_DN);  
           ObjectCreate("SignalRVm30", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalRVm30"," * ", 16, "Arial Bold",  clr_m30);
   ObjectSet("SignalRVm30", OBJPROP_CORNER, 3);
   ObjectSet("SignalRVm30", OBJPROP_XDISTANCE, 45+Adjust_Side_to_side);
   ObjectSet("SignalRVm30", OBJPROP_YDISTANCE, 45+Shift_UP_DN);  
           ObjectCreate("SignalRVm15", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalRVm15"," * ", 16, "Arial Bold",  clr_m15);
   ObjectSet("SignalRVm15", OBJPROP_CORNER, 3);
   ObjectSet("SignalRVm15", OBJPROP_XDISTANCE, 55+Adjust_Side_to_side);
   ObjectSet("SignalRVm15", OBJPROP_YDISTANCE, 45+Shift_UP_DN);  
           ObjectCreate("SignalRVm5", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalRVm5"," * ", 16, "Arial Bold",  clr_m5);
   ObjectSet("SignalRVm5", OBJPROP_CORNER, 3);
   ObjectSet("SignalRVm5", OBJPROP_XDISTANCE, 65+Adjust_Side_to_side);
   ObjectSet("SignalRVm5", OBJPROP_YDISTANCE, 45+Shift_UP_DN);  
           ObjectCreate("SignalRVm1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalRVm1"," * ", 16, "Arial Bold",  clr_m1);
   ObjectSet("SignalRVm1", OBJPROP_CORNER, 3);
   ObjectSet("SignalRVm1", OBJPROP_XDISTANCE, 75+Adjust_Side_to_side);
   ObjectSet("SignalRVm1", OBJPROP_YDISTANCE, 45+Shift_UP_DN);  

   //SiGNAL TRend
           ObjectCreate("TRtext", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TRtext","TR", 7, "Arial",  Label_color);
   ObjectSet("TRtext", OBJPROP_CORNER, 3);
   ObjectSet("TRtext", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("TRtext", OBJPROP_YDISTANCE, 40+Shift_UP_DN);  
           ObjectCreate("SignalTRd1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalTRd1"," * ", 16, "Arial Bold",  color_d1);
   ObjectSet("SignalTRd1", OBJPROP_CORNER, 3);
   ObjectSet("SignalTRd1", OBJPROP_XDISTANCE, 15+Adjust_Side_to_side);
   ObjectSet("SignalTRd1", OBJPROP_YDISTANCE, 30+Shift_UP_DN);  
           ObjectCreate("SignalTRh4", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalTRh4"," * ", 16, "Arial Bold",  color_h4);
   ObjectSet("SignalTRh4", OBJPROP_CORNER, 3);
   ObjectSet("SignalTRh4", OBJPROP_XDISTANCE, 25+Adjust_Side_to_side);
   ObjectSet("SignalTRh4", OBJPROP_YDISTANCE, 30+Shift_UP_DN);  
           ObjectCreate("SignalTRh1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalTRh1"," * ", 16, "Arial Bold",  color_h1);
   ObjectSet("SignalTRh1", OBJPROP_CORNER, 3);
   ObjectSet("SignalTRh1", OBJPROP_XDISTANCE, 35+Adjust_Side_to_side);
   ObjectSet("SignalTRh1", OBJPROP_YDISTANCE, 30+Shift_UP_DN);  
           ObjectCreate("SignalTRm30", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalTRm30"," * ", 16, "Arial Bold",  color_m30);
   ObjectSet("SignalTRm30", OBJPROP_CORNER, 3);
   ObjectSet("SignalTRm30", OBJPROP_XDISTANCE, 45+Adjust_Side_to_side);
   ObjectSet("SignalTRm30", OBJPROP_YDISTANCE, 30+Shift_UP_DN);  
           ObjectCreate("SignalTRm15", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalTRm15"," * ", 16, "Arial Bold",  color_m15);
   ObjectSet("SignalTRm15", OBJPROP_CORNER, 3);
   ObjectSet("SignalTRm15", OBJPROP_XDISTANCE, 55+Adjust_Side_to_side);
   ObjectSet("SignalTRm15", OBJPROP_YDISTANCE, 30+Shift_UP_DN);  
           ObjectCreate("SignalTRm5", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalTRm5"," * ", 16, "Arial Bold",  color_m5);
   ObjectSet("SignalTRm5", OBJPROP_CORNER, 3);
   ObjectSet("SignalTRm5", OBJPROP_XDISTANCE, 65+Adjust_Side_to_side);
   ObjectSet("SignalTRm5", OBJPROP_YDISTANCE, 30+Shift_UP_DN);  
           ObjectCreate("SignalTRm1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalTRm1"," * ", 16, "Arial Bold",  color_m1);
   ObjectSet("SignalTRm1", OBJPROP_CORNER, 3);
   ObjectSet("SignalTRm1", OBJPROP_XDISTANCE, 75+Adjust_Side_to_side);
   ObjectSet("SignalTRm1", OBJPROP_YDISTANCE, 30+Shift_UP_DN);  

   //SiGNAL BuySell
           ObjectCreate("BStext", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("BStext","BS", 7, "Arial",  Label_color);
   ObjectSet("BStext", OBJPROP_CORNER, 3);
   ObjectSet("BStext", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("BStext", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  
           ObjectCreate("SignalBSd1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalBSd1"," 7 ", 9, "Arial Bold",  cOlr_d1);
   ObjectSet("SignalBSd1", OBJPROP_CORNER, 3);
   ObjectSet("SignalBSd1", OBJPROP_XDISTANCE, 18+Adjust_Side_to_side);
   ObjectSet("SignalBSd1", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  
           ObjectCreate("SignalBSh4", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalBSh4"," 6 ", 9, "Arial Bold",  cOlr_h4);
   ObjectSet("SignalBSh4", OBJPROP_CORNER, 3);
   ObjectSet("SignalBSh4", OBJPROP_XDISTANCE, 28+Adjust_Side_to_side);
   ObjectSet("SignalBSh4", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  
           ObjectCreate("SignalBSh1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalBSh1"," 5 ", 9, "Arial Bold",  cOlr_h1);
   ObjectSet("SignalBSh1", OBJPROP_CORNER, 3);
   ObjectSet("SignalBSh1", OBJPROP_XDISTANCE, 38+Adjust_Side_to_side);
   ObjectSet("SignalBSh1", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  
           ObjectCreate("SignalBSm30", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalBSm30"," 4 ", 9, "Arial Bold",  cOlr_m30);
   ObjectSet("SignalBSm30", OBJPROP_CORNER, 3);
   ObjectSet("SignalBSm30", OBJPROP_XDISTANCE, 48+Adjust_Side_to_side);
   ObjectSet("SignalBSm30", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  
           ObjectCreate("SignalBSm15", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalBSm15"," 3 ", 9, "Arial Bold",  cOlr_m15);
   ObjectSet("SignalBSm15", OBJPROP_CORNER, 3);
   ObjectSet("SignalBSm15", OBJPROP_XDISTANCE, 58+Adjust_Side_to_side);
   ObjectSet("SignalBSm15", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  
           ObjectCreate("SignalBSm5", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalBSm5"," 2 ", 9, "Arial Bold",  cOlr_m5);
   ObjectSet("SignalBSm5", OBJPROP_CORNER, 3);
   ObjectSet("SignalBSm5", OBJPROP_XDISTANCE, 68+Adjust_Side_to_side);
   ObjectSet("SignalBSm5", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  
           ObjectCreate("SignalBSm1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SignalBSm1"," 1 ", 9, "Arial Bold",  cOlr_m1);
   ObjectSet("SignalBSm1", OBJPROP_CORNER, 3);
   ObjectSet("SignalBSm1", OBJPROP_XDISTANCE, 78+Adjust_Side_to_side);
   ObjectSet("SignalBSm1", OBJPROP_YDISTANCE, 25+Shift_UP_DN);  

   //Info Label

           ObjectCreate("mus", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("mus", "YaOPOrek by masemus", 7, "Trebucet",  Label_color);
   ObjectSet("mus", OBJPROP_CORNER, 3);
   ObjectSet("mus", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("mus", OBJPROP_YDISTANCE, 5+Shift_UP_DN);  

           ObjectCreate("Pair", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Pair", Symbol(), 12, "Arial Bold",  color_m5);
   ObjectSet("Pair", OBJPROP_CORNER, 3);
   ObjectSet("Pair", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("Pair", OBJPROP_YDISTANCE, 175+Shift_UP_DN);  

           ObjectCreate("Price", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Price",""+Teks+"", 18, "Arial Bold",  color_m15);
   ObjectSet("Price", OBJPROP_CORNER, 3);
   ObjectSet("Price", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("Price", OBJPROP_YDISTANCE, 150+Shift_UP_DN);  

           ObjectCreate("DAV", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("DAV",""+DAV+"", 9, "Arial Bold",  color_av);
   ObjectSet("DAV", OBJPROP_CORNER, 3);
   ObjectSet("DAV", OBJPROP_XDISTANCE, 35+Adjust_Side_to_side);
   ObjectSet("DAV", OBJPROP_YDISTANCE, 135+Shift_UP_DN);  
           ObjectCreate("DAV2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("DAV2"," D Av. ", 7, "Arial",  Label_color);
   ObjectSet("DAV2", OBJPROP_CORNER, 3);
   ObjectSet("DAV2", OBJPROP_XDISTANCE, 35+Adjust_Side_to_side);
   ObjectSet("DAV2", OBJPROP_YDISTANCE, 125+Shift_UP_DN);  

           ObjectCreate("HILO", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("HILO",""+HILO+"", 9, "Arial Bold",  Gold);
   ObjectSet("HILO", OBJPROP_CORNER, 3);
   ObjectSet("HILO", OBJPROP_XDISTANCE, 35+Adjust_Side_to_side);
   ObjectSet("HILO", OBJPROP_YDISTANCE, 110+Shift_UP_DN);  
           ObjectCreate("HILO2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("HILO2"," Hi-L0 ", 7, "Arial",  Label_color);
   ObjectSet("HILO2", OBJPROP_CORNER, 3);
   ObjectSet("HILO2", OBJPROP_XDISTANCE, 35+Adjust_Side_to_side);
   ObjectSet("HILO2", OBJPROP_YDISTANCE, 100+Shift_UP_DN);  

           ObjectCreate("PipsToOpen", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("PipsToOpen",""+PIPS+"", 9, "Arial Bold",  color_pip);
   ObjectSet("PipsToOpen", OBJPROP_CORNER, 3);
   ObjectSet("PipsToOpen", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("PipsToOpen", OBJPROP_YDISTANCE, 110+Shift_UP_DN);  
           ObjectCreate("PipsToOpen2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("PipsToOpen2"," PIPS ", 7, "Arial",  Label_color);
   ObjectSet("PipsToOpen2", OBJPROP_CORNER, 3);
   ObjectSet("PipsToOpen2", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("PipsToOpen2", OBJPROP_YDISTANCE, 100+Shift_UP_DN);  

           ObjectCreate("Spread", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Spread",""+SPREAD+"", 9, "Arial Bold",  Gold);
   ObjectSet("Spread", OBJPROP_CORNER, 3);
   ObjectSet("Spread", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("Spread", OBJPROP_YDISTANCE, 135+Shift_UP_DN);  
           ObjectCreate("Spread2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Spread2"," Sprd ", 7, "Arial",  Label_color);
   ObjectSet("Spread2", OBJPROP_CORNER, 3);
   ObjectSet("Spread2", OBJPROP_XDISTANCE, 5+Adjust_Side_to_side);
   ObjectSet("Spread2", OBJPROP_YDISTANCE, 125+Shift_UP_DN);  


   //******************************************************************************************************************
 
 //----
   return(0);
  }

//+------------------------------------------------------------------+